SystemOrganization addCategory: #MemoryMentor!

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:38:58.14'!
intAt: index
	| word |
	<primitive: 165>
	word := self basicAt: index.
	word < 16r3FFFFFFF ifTrue:[^word]. "Avoid LargeInteger computations"
	^word >= 16r80000000	"Negative?!!"
		ifTrue:["word - 16r100000000"
				(word bitInvert32 + 1) negated]
		ifFalse:[word]! !

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:44:13.346'!
intAt: index put: anInteger
	| word |
	<primitive: 166>
	anInteger < 0
		ifTrue:[anInteger < -16r80000000 ifTrue: [self error: anInteger asString , ' out of range'].
				"word := 16r100000000 + anInteger"
				word := (anInteger + 1) negated bitInvert32]
		ifFalse:[anInteger > 16r7FFFFFFF ifTrue: [self error: anInteger asString , ' out of range'].
				word := anInteger].
	self  basicAt: index put: word.
	^anInteger! !

Object subclass: #MMMemory
	instanceVariableNames: 'startAdress memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:42:20.88'!
at: adress putByte: byte
	memory byteAt: (self indexForAdress: adress) put: byte! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:46:36.05'!
at: adress putInt: int
	memory intAt: (self indexForAdress: adress) put: int! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:30:32.702'!
byteAt: adress
	 ^ memory at: (self indexForAdress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:24:59.088'!
byteSize
	^ memory size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:30:26.288'!
indexForAdress: adress
	^ adress - startAdress + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:23:51.542'!
initialize 
	super initialize.
	startAdress := 16rCAFE.
	memory := ByteArray new: 100.! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 11:39:53.016'!
intAt: adress
	 ^ memory intAt: (self indexForAdress: adress)! !
